<template>
    <div>
        <div v-if="field">

            <v-card v-if="field.teachers" flat outlined class="ma-3">
                <v-card-title class="text-h4 font-weight-bold">
                    {{ field.field_name }}
                </v-card-title>
                <v-card-subtitle class="text-h6">
                    {{ field.teachers[0].fullName }}
                </v-card-subtitle>
            </v-card>

            <div class="text-center">
                <lesson-edit v-bind:isAdd="true"></lesson-edit>
            </div>

            <!--Lesson List-->
            <v-list>
                <v-list-item-group mandatory v-model="lessonSelected" color="black">
                    <draggable v-model="draggableLessons" :disabled="!enabled">
                        <!--One Lesson -->
                        <div v-for="(menuItem, lessonIndex) in draggableLessons" :key="menuItem.order"
                                @click.prevent="changeCurrentLesson(lessonIndex)">
                            <v-list-item
                                draggable="true">
                                <!--Lesson Icon-->
                                <v-list-item-icon>
                                    <v-icon>{{ getIcon(menuItem) }}</v-icon>
                                </v-list-item-icon>

                                <!--Lesson Title-->
                                <v-list-item-content>
                                    <v-list-item-title>
                                        <h3>{{ menuItem.title }}</h3>
                                    </v-list-item-title>
                                </v-list-item-content>

                            </v-list-item>

                            <!--Nested Paragraph List-->
                            <!--ID technique does not work because history is already using the technique-->
                            <paragraph-draggable
                                @sort="onSort"
                                :enabled="!enabled"
                                :index="lessonIndex"
                                :lesson="menuItem"/>

                        </div>
                    </draggable>
                    <v-divider></v-divider>
                </v-list-item-group>
            </v-list>
        </div>
    </div>
</template>

<script>
import { mapGetters } from "vuex";
import draggable from "vuedraggable";

import { SET_CURRENTLESSONID, SET_FIELD } from "@/store/mutations.type";
import Services from "@/services/api"
import { REORDER_LESSONS, REORDER_PARAGRAPHS } from "@/store/actions.type";
import ParagraphDraggable from '@/components/ParagraphDraggable.component';
import LessonEdit from '@/components/LessonEdit.component';

export default {
    name: "navigation-drawer",
    components: {
        ParagraphDraggable,
        draggable,
        LessonEdit
    },
    computed: {
        ...mapGetters(['currentLessonId', 'field', 'lessons', 'user']),
        enabled() {
            return this.user && (this.user.type === 'TEACHER' || this.user.type === 'ADMIN')
        },
        lessonSelected: {
            get: function () {
                return this.currentLessonId;
            },
            set: function (newSelectedId) {
                return newSelectedId
            }
        },
        draggableLessons: {
            get: function () {
                return this.lessons;
            },
            set: function (newLessons) {
                this.$store.dispatch(REORDER_LESSONS, {
                    newLessons,
                    user: this.user
                })
            }
        },
    },
    async beforeMount() {
        await this.setField();
    },
    watch: {
        '$route.params.id': async function (id) {
            await this.setField(id);
        }
    },
    methods: {
        getIcon: function ({ type }) {
            return type === "CM" ? 'mdi-school' : 'mdi-file-document-edit';
        },
        changeCurrentLesson(index) {
            this.$store.commit(SET_CURRENTLESSONID, index);
        },
        async setField(id) {
            if (!id) {
                id = this.$route.params.id;
            }
            const field = await Services.Fields.getField(id)
                .catch(() => {
                    this.$router.push({ name: "404 Not found" })
                });

            this.$store.commit(SET_FIELD, field);
        },
        onSort(payload) {
            this.$store.dispatch(REORDER_PARAGRAPHS, {
                ...payload,
                user: this.user,
                lessons: this.lessons
            })
        }
    },
}
</script>
